      SUBROUTINE AFH5C(NM,N,A,D,E,E2,TAU)
         INTEGER N,NM
         REAL A,AA01C,D,E,E2,TAU
         DIMENSION A(NM,N),D(N),E(N),E2(N),TAU(2,N)
         INTEGER I,II,J,JM1,JP1,K,L
         REAL F,FI,G,GI,H,HH,SCALE,SI,SYS056,X,Y
C     SYS056 = SYS055
         DATA  SYS056 /1.175495E-38/
         AA01C(X,Y) = CABS(CMPLX(X,Y))
       TAU(1,N) = 1.0
       TAU(2,N) = 0.0
C     I=N,1,-1
       DO 180 II = 1, N
          I = N + 1 - II
          L = I - 1
          H = 0.0
          SCALE = 0.0
          IF (L .LT. 1) GO TO 30
C     HOPMPOBKA CTPOK
             DO 10 K = 1, L
                SCALE = SCALE + ABS(A(I,K)) + ABS(A(K,I))
   10        CONTINUE
             IF (SCALE .GE. SYS056) GO TO 40
                TAU(1,L) = 1.0
                TAU(2,L) = 0.0
                DO 20 K = 1, L
                   A(I,K) = 0.
                   A(K,I) = 0.
   20           CONTINUE
   30        CONTINUE
             E(I) = 0.0
             E2(I) = 0.0
             GO TO 170
   40     CONTINUE
          DO 50 K = 1, L
             A(I,K) = A(I,K)/SCALE
             A(K,I) = A(K,I)/SCALE
             H = H + A(I,K)*A(I,K) + A(K,I)*A(K,I)
   50     CONTINUE
          E2(I) = SCALE*SCALE*H
          G = SQRT(H)
          E(I) = SCALE*G
          F = AA01C(A(I,L),A(L,I))
C OPM-E CEYEO A.EMEHTA MATP T
          IF (F .LE. SYS056) GO TO 60
             TAU(1,L) = (A(L,I)*TAU(2,I) - A(I,L)*TAU(1,I))/F
             SI = (A(I,L)*TAU(2,I) + A(L,I)*TAU(1,I))/F
             H = H + F*G
             G = 1.0 + G/F
             A(I,L) = G*A(I,L)
             A(L,I) = G*A(L,I)
             IF (L .EQ. 1) GO TO 150
                GO TO 70
   60     CONTINUE
          TAU(1,L) = -TAU(1,I)
          SI = TAU(2,I)
          A(L,I) = 0.
          A(I,L) = G
   70     CONTINUE
          F = 0.0
          DO 120 J = 1, L
             G = 0.0
             GI = 0.0
             IF (J .EQ. 1) GO TO 90
                JM1 = J - 1
C OPM-E A*U
                DO 80 K = 1, JM1
                   G = G + A(J,K)*A(I,K) + A(K,J)*A(K,I)
                   GI = GI - A(J,K)*A(K,I) + A(K,J)*A(I,K)
   80           CONTINUE
   90        CONTINUE
             G = G + A(J,J)*A(I,J)
             GI = GI - A(J,J)*A(J,I)
             JP1 = J + 1
             IF (L .LT. JP1) GO TO 110
                DO 100 K = JP1, L
                   G = G + A(K,J)*A(I,K) - A(J,K)*A(K,I)
                   GI = GI - A(K,J)*A(K,I) - A(J,K)*A(I,K)
  100           CONTINUE
C OPM-E P
  110        CONTINUE
             E(J) = G/H
             TAU(2,J) = GI/H
             F = F + E(J)*A(I,J) - TAU(2,J)*A(J,I)
  120     CONTINUE
          HH = F/(H + H)
C PEOPAOBAHE MACCBA A
          DO 140 J = 1, L
             F = A(I,J)
             G = E(J) - HH*F
             E(J) = G
             FI = -A(J,I)
             GI = TAU(2,J) - HH*FI
             TAU(2,J) = -GI
             A(J,J) = A(J,J) - 2.0*(F*G + FI*GI)
             IF (J .EQ. 1) GO TO 140
                JM1 = J - 1
                DO 130 K = 1, JM1
                   A(J,K) = A(J,K) - F*E(K) - G*A(I,K) + FI*TAU(2,K)
     1                       + GI*A(K,I)
                   A(K,J) = A(K,J) - F*TAU(2,K) - G*A(K,I) - FI*
     1                      E(K) - GI*A(I,K)
  130           CONTINUE
  140     CONTINUE
  150     CONTINUE
          DO 160 K = 1, L
             A(I,K) = SCALE*A(I,K)
             A(K,I) = SCALE*A(K,I)
  160     CONTINUE
          TAU(2,L) = -SI
  170     CONTINUE
          D(I) = A(I,I)
          A(I,I) = SCALE*SQRT(H)
  180  CONTINUE
       RETURN
      END
